%% commands for KS as 2nd order sys, incl. Hopf branches 
close all; keep pphome; p=[]; 
%% init and zero-branch 
lx=2; nx=100; % domain and discr
al=0.42; m0=0; par=[al; m0; 0; 0];  % m0=mass, par(3)=eps, par(4)=s (speed) 
p=ksinit(p,nx,lx,par); p=setfn(p,'0'); screenlayout(p); 
p.sw.verb=2; p.nc.mu1=10; p.nc.mu2=1;  p.nc.ilam=[1 3]; p=cont(p,40); 
p.sol.ds=-0.001; p.nc.dsmax=0.001; % now some more steps with small stepsize
p.nc.mu2=5; p=cont(p,20); p.file.smod=10; p=cont(p,10); 
%% Turing-branch(es) 
for i=1:3; 
    is=mat2str(i); p=swibra('0',['bpt' is],is,i*0.2); p=cont(p,2); p.file.smod=50; 
    p.nc.nq=2; p.nc.ilam=[1 3 4]; p.nc.dsmax=6; p.nc.tol=1e-6; p=cont(p,i^2*17); 
end 
%% 1st Hopf  
figure(2); clf; para=4; ds=1; aux.dlam=0; aux.nqnew=0; aux.tl=30; aux.xif=0.1; 
aux.nqh=2; aux.qfh=@qfh; aux.qfhder=@qfhjac; % function handles to hopf contraints 
p=hoswibra('2','hpt1',ds,para,'h1',aux); p.nc.ilam=1; p.hopf.ilam=[3 4]; p.hopf.fltol=5e-2; 
p.hopf.sec=1; p.nc.dsmax=2; p.file.smod=5; p.nc.tol=1e-4; p=cont(p,30); %p=cont(p,30); 
%% 2nd Hopf 
aux.tl=30; aux.xif=1e-1; 
p=hoswibra('3','hpt1',1,para,'h2',aux); p.nc.ilam=1; p.hopf.ilam=[3 4]; 
p.hopf.sec=1; p.nc.tol=1e-2; p.nc.dsmax=2; p.file.smod=5; 
p.hopf.flcheck=2; p.hopf.fltol=5e-2; 
p=cont(p,5); p.nc.tol=1e-4; p.hopf.flcheck=1; p=cont(p,35);
%% BD plot 
pcmp=6; figure(3); clf; 
plotbra('0','pt70',3,pcmp,'cl','k','lsw',0); 
plotbra('1',3,pcmp,'cl',p2pc('b1'),'fp',1);
plotbra('2',3,pcmp,'cl',p2pc('b2'));
plotbra('3',3,pcmp,'cl',p2pc('b3'));
plotbra('h1','pt30',3,pcmp,'cl','r'); 
plotbra('h2','pt40',3,pcmp,'cl','m'); 
%% sol plot 
plotsol('2','hpt1'); pause; plotsol('3','hpt1'); pause
hoplotf('h1','pt15',1,1); figure(1); title('h1/pt15'); view(20,70); 
xlabel('x'); ylabel('t'); zlabel('u_1'); pause;
hoplotf('h1','pt30',1,1); figure(1); title('h1/pt30'); view(20,70); 
xlabel('x'); ylabel('t'); zlabel('u_1'); pause;
hoplotf('h2','pt40',1,1); figure(1); title('h2/pt40'); view(20,70); 
xlabel('x'); ylabel('t'); zlabel('u_1'); 